// BallView.cpp : implementation of the CBallView class
//

#include "stdafx.h"
#include "Ball.h"

#include "BallDoc.h"
#include "BallView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ABS(x) ((x) < 0? -(x) : (x) > 0? (x) : 0)
/////////////////////////////////////////////////////////////////////////////
// CBallView

IMPLEMENT_DYNCREATE(CBallView, CView)

BEGIN_MESSAGE_MAP(CBallView, CView)
	//{{AFX_MSG_MAP(CBallView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_COMMAND(ID_EDIT_SPEED, OnEditSpeed)
	ON_COMMAND(ID_EDIT_COLOR, OnEditColor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBallView construction/destruction

CBallView::CBallView() : ptRacket(0,0)
{
	clrBall = RGB(0,0,255);
}

CBallView::~CBallView()
{
}

BOOL CBallView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBallView drawing

void CBallView::OnDraw(CDC* pDC)
{
	CBallDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CBallView diagnostics

#ifdef _DEBUG
void CBallView::AssertValid() const
{
	CView::AssertValid();
}

void CBallView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBallDoc* CBallView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBallDoc)));
	return (CBallDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBallView message handlers

int CBallView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{									//    
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
									//   
	if (!SetTimer(1, MaxSpeed, NULL))
	{
		MessageBox(_T("   "),
					_T("Ball"), MB_ICONEXCLAMATION | MB_OK);
		return -1;
	}
									//   
	CDC* pDC = GetDC();				//  
	ptPixel.x = pDC->GetDeviceCaps(ASPECTX);
	ptPixel.y = pDC->GetDeviceCaps(ASPECTY);
	ReleaseDC(pDC);					//  
	return 0;
}

void CBallView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	ptRacket = point;	
	CView::OnLButtonDown(nFlags, point);
}

void CBallView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
										//    
	ptLeftTop.x = cx >> 1;
	ptLeftTop.y = cy >> 1;
										// 1/16    
	long Scale = min((long)cx * ptPixel.x,
								(long)cy * ptPixel.y) >> 4;

										//      
	szRadius.cx = (int)(Scale / ptPixel.x);
	szRadius.cy = (int)(Scale / ptPixel.y);
										//  
	ptRad2.x = szRadius.cx >> 1;
	ptRad2.y = szRadius.cy >> 1;
	ptRad4.x = szRadius.cx >> 2;
	ptRad4.y = szRadius.cy >> 2;
										//   
	ptMove.x = max(1, ptRad4.x);
	ptMove.y = max(1, ptRad4.y);
	ptDs.x = ABS(ptMove.x);
	ptDs.y = ABS(ptMove.y);
										//   
	if (szRadius.cx)
		uSpeed = ptDs.x * MaxSpeed / szRadius.cx;
	NewBall();							//  bitmap- 
}

void CBallView::OnTimer(UINT nIDEvent) 
{
	if (Bmp.m_hObject == NULL)
		return;
	CRect r;
	GetClientRect (&r);					//    
	CClientDC dc (this);				// 
	CDC dcMem;
	dcMem.CreateCompatibleDC (&dc);
										//   Bmp    
	CBitmap* pOld = dcMem.SelectObject (&Bmp);

										//    ()
	CPoint ball = ptLeftTop + szRadius + szRadius;
	CRect rBmp (ptLeftTop, szBmp);		//  
	if (rBmp.PtInRect (ptRacket))
	{									//     
										//    
		CPoint wanted = ptMove + ball - ptRacket;
		int vx = max(1, wanted.x),
				vy = max(1, wanted.y);
										//    ?
		bool bFast = ABS(vx) > szRadius.cx;

		if (!bFast)
			ptMove.x = vx;				//  ,  
										//     
		bFast = ABS(vy) > szRadius.cy;
		if (!bFast)
			ptMove.y = vy;
										//    
		ptDs.x = ABS(ptMove.x);
		ptDs.y = ABS(ptMove.y);
										//   
		double vv = (ptDs.x * ptDs.x + ptDs.y * ptDs.y);
		double v =sqrt(double(vv));		//   
										//  
		uSpeed = UINT(v * MaxSpeed / szRadius.cx);
		ptRacket.x = ptRacket.y = 0;	//  
	}
										//      
	dc.BitBlt ( ptLeftTop.x, ptLeftTop.y,
						szBmp.cx, szBmp.cy, &dcMem, 0, 0, SRCCOPY);
										//   
	bool	OutX = ptLeftTop.x + szBmp.cx - szRadius.cx
						>= r.right || ptLeftTop.x +	szRadius.cx <= 0,
			OutY = ptLeftTop.y + szBmp.cy - szRadius.cx
						>= r.bottom || ptLeftTop.y + szRadius.cx <= 0;

	if (OutX)							//   
		ptMove.x = -ptMove.x;
	if (OutY)
		ptMove.y = -ptMove.y;

	ptLeftTop += ptMove;				//   

	dcMem.SelectObject(pOld);			//   GDI
	dcMem.DeleteDC();					//  
	CView::OnTimer(nIDEvent);			//   
}

void CBallView::NewBall()
{										//  bitmap-
	szBmp.cx = szRadius.cx << 2;
	szBmp.cy = szRadius.cy << 2;
										//   bitmap
	if (Bmp.m_hObject != NULL)
		Bmp.DeleteObject();

	CClientDC dc(this);					//  
	CDC dcMem;							//   

										//     
	dcMem.CreateCompatibleDC (&dc);
										//   bitmap
	Bmp.CreateCompatibleBitmap (&dc, szBmp.cx, szBmp.cy);
	ASSERT (Bmp.m_hObject != NULL);
										//  bitmap   
	CBitmap* pBmp = dcMem.SelectObject (&Bmp);
										//   - 
	CRect r (0, 0, szBmp.cx, szBmp.cy);
										//    
	CBrush erazeBr ( ::GetSysColor (COLOR_WINDOW) );
										//  
	dcMem.FillRect (&r, &erazeBr);

	CBrush newBr (HS_DIAGCROSS, 0L);	//   
										//      
	CBrush* oldBr = dcMem.SelectObject (&newBr);
	dcMem.SetBkColor(clrBall);			//  
										//  
	dcMem.Ellipse( szRadius.cx, szRadius.cy,
					szBmp.cx-szRadius.cx, szBmp.cy-szRadius.cy);

	dcMem.SelectObject (oldBr);			//  
	dcMem.SelectObject (pBmp);			//  
	dcMem.DeleteDC();					//    
}

void CBallView::ChangeSpeed()
{
	KillTimer(1);						//   
	if ( !SetTimer (1, MaxSpeed-uSpeed+1, NULL) )
	{									//   
		MessageBox ("  ",
							"Ball",MB_ICONEXCLAMATION | MB_OK);
		DestroyWindow();
	}
										// 
	int move = max (1, uSpeed * szRadius.cx/MaxSpeed);
	ptMove = CPoint (move, move);
	ptDs.x = ABS(ptMove.x);
	ptDs.y = ABS(ptMove.y);
}

/////////////////////////////////////////////////////////////////////////////
// CSpeedDlg dialog


CSpeedDlg::CSpeedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpeedDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpeedDlg)
	uSpeed = 0;
	//}}AFX_DATA_INIT
}


void CSpeedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpeedDlg)
	DDX_Text(pDX, IDC_SPEED, uSpeed);
	DDV_MinMaxUInt(pDX, uSpeed, 1, 50);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpeedDlg, CDialog)
	//{{AFX_MSG_MAP(CSpeedDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpeedDlg message handlers

void CBallView::OnEditSpeed() 
{
	CSpeedDlg dlg;
	dlg.uSpeed = uSpeed;
	if (dlg.DoModal()!= IDOK)
		return;
	uSpeed = dlg.uSpeed;
	ChangeSpeed();
}

void CBallView::OnEditColor() 
{
	CColorDialog dlg(clrBall);
	if (dlg.DoModal()!=IDOK)
		return;
	clrBall = dlg.m_cc.rgbResult;
	NewBall();
}
