// ControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "life.h"
#include "LifeDoc.h"
#include "ControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlDlg dialog


CControlDlg::CControlDlg (CLifeDoc* p)
	: CDialog(CControlDlg::IDD, NULL)
{
	pDoc = (CLifeDoc*)p;
	pGo=NULL;
	pStop=NULL;
}


void CControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CControlDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CControlDlg, CDialog)
	//{{AFX_MSG_MAP(CControlDlg)
	ON_BN_CLICKED(IDC_DEC, OnDec)
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_BN_CLICKED(IDC_INC, OnInc)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlDlg message handlers

void CControlDlg::OnDec() 
{							//     
	if (pDoc->uScale > MinScale)
		(pDoc->uScale)--;
	pDoc->ChangeView();
}

void CControlDlg::OnInc() 
{							//     
	if (pDoc->uScale < MaxScale)
		(pDoc->uScale)++;  
	pDoc->ChangeView();		//  
}

void CControlDlg::OnClear() 
{
	pDoc->ClearView();		//   
	OnEdit();				//    
}

void CControlDlg::OnGo() 
{
	pDoc->LifeGo(true);		//   ,
	EnableButtons (false);	//   Go 
}

void CControlDlg::OnEdit() 
{
	pDoc->LifeGo(false);	//    ( ),
	EnableButtons (true);	//   Go 
}

void CControlDlg::PostNcDestroy() {	delete this; }

void CControlDlg::OnCancel() 
{
	pDoc->pCtrlDlg=NULL;	//    
	DestroyWindow();		//  Windows  (hWnd)
}

void CControlDlg::EnableButtons (bool b)
{								//  
	pGo  =(CButton*)GetDlgItem(IDC_GO);
								//  ,  b==true
	pGo->EnableWindow(b);
	pStop=(CButton*)GetDlgItem(IDC_EDIT);
								//  ,  b==false
	pStop->EnableWindow(!b);
}

BOOL CControlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	EnableButtons (pDoc->bEditMode);
	MoveWindow (660,300,92,230);
	return TRUE;
}
