// LifeDoc.cpp : implementation of the CLifeDoc class
//

#include "stdafx.h"
#include "Life.h"

#include "LifeDoc.h"
#include "LifeView.h"
#include "ControlDlg.h"
#include "SizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLifeDoc

IMPLEMENT_DYNCREATE(CLifeDoc, CDocument)

BEGIN_MESSAGE_MAP(CLifeDoc, CDocument)
	//{{AFX_MSG_MAP(CLifeDoc)
	ON_COMMAND(ID_VIEW_CONTROL, OnViewControl)
	ON_COMMAND(ID_VIEW_DEMO, OnViewDemo)
	ON_COMMAND(ID_VIEW_OPTIONS, OnViewOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLifeDoc construction/destruction

CLifeDoc::CLifeDoc()
{
	pCtrlDlg = NULL;
	pView = NULL;
	uTimerId=1;
	ptScroll=CPoint(1,1);
}

CLifeDoc::~CLifeDoc()
{
}

BOOL CLifeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	uX = 150;
	uY = 100;
	uScale = 5;
	uTime = 1000;
	bEditMode = true;		//   
	GetView();				//  
	StopTimer();			//  
	InitOptions();			//    
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CLifeDoc serialization

void CLifeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CLifeDoc diagnostics

#ifdef _DEBUG
void CLifeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CLifeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLifeDoc commands

void CLifeDoc::OnViewControl() 
{
	if (!pCtrlDlg)			//    ,   
	{						//     
		pCtrlDlg = new CControlDlg(this);
		pCtrlDlg->Create(IDD_CONTROL);
	}
	else					// ,     
		pCtrlDlg->SetActiveWindow();
}

void CLifeDoc::OnViewDemo() 
{								//   
	if (pCtrlDlg)				//    ,
		pCtrlDlg->OnCancel();	//   
	ClearView();				//  
	ptScroll = CPoint(0,0);
	pView->ChangeScroll();
	InitOptions();				//   
	DemoFill();
	LifeGo(true);				//  ,   
	UpdateAllViews (NULL);		//   
}

void CLifeDoc::OnViewOptions()
{
	GetView();							//   
	StopTimer();						//  
	bSizeChanged=false;					//  
	CSizeDlg(this).DoModal();			//    
	if (bSizeChanged)					//    
	{
		NewField(F1);					//     
		NewField(F2);					//   
		uYOld = uY;
		fOld=F1;						//    
		fNew=F2;						//   
		bEven = true;					//   
		bSizeChanged=false;				//  
		bEditMode=true;					//    
		if (pCtrlDlg)					//    ,
										//     
			pCtrlDlg->EnableButtons (true);
	}
	pView->InitView();					//  
	if (!bEditMode)						//   , 
		LifeGo (true);					//  
	UpdateAllViews (NULL);
}

void CLifeDoc::NewField (BYTE**& f)		//  
{
	UINT i;								//  
	if (f)								//    
	{									//    2-  
		for (i=0;  i<uYOld+1;  ++i)
			free (f[i]);				//  
										//  ,   
		free(f);
	}
										//      
	f = (BYTE**)malloc ((uY+1)*sizeof(BYTE*));

	for (i=0;  i<uY+1;  ++i)
	{									//    
		f[i] = (BYTE*)malloc (uX+1);	//  
										//    ( None)
		memset (f[i],0, uX+1);
	}
}

void CLifeDoc::InitOptions()
{								//  
	bEven = true;				// - (  )
	bSizeChanged=false;			//  :   
	uX = 150;					//   
	uY = uYOld = 100;
	uScale = 5;					// 
	uTime = 1000;				//   ( )
	F1 = F2 = NULL;				//  
	fOld = fNew = NULL;			//   
	NewField(F1);				//   
	NewField(F2);				//   
	fOld=F1;					//    ()
	fNew=F2;					//    ()
	NewColor = RGB(0,255,0);	//    
	OldColor = RGB(255,0,0);
	DiedColor= RGB(192,192,192);
}

void CLifeDoc::GetView()
{
				//   ,   
	POSITION pos = GetFirstViewPosition();
				//         
	pView =(CLifeView*) GetNextView(pos);
}

void CLifeDoc::StopTimer()
{
	if (pView)		//   ,    
		pView->KillTimer(uTimerId);
}

void CLifeDoc::LifeGo (bool b)
{
	if (bEditMode = !b)		//    
	{						//   , 
		GetView();			//   
		StopTimer();		//     
	}
	else
	{						//    , 
		GetView();			//  
		pView->SetTimer(uTimerId,uTime,NULL);
	}
	UpdateAllViews (NULL);
}

void CLifeDoc::ClearView()
{									//  
	for (UINT y=1; y<uY; y++)		//    
		for (UINT x=1; x<uX; x++)
			fNew[y][x] = None;		//   
	GetView();
	pView->Invalidate();			//  
}

void CLifeDoc::DemoFill()
{			//       
	for (UINT y=uY/4; y<uY*3/4; y++)
		for (UINT x=uX/4; x<uX*3/4; x++)	//   
			fNew[y][x] = Young;				//   
}

void CLifeDoc::ChangeView()
{
	GetView();				//   
	pView->ChangeScroll();	//    
	pView->Invalidate();	//    
}

void CLifeDoc::NextStage()
{									//   
	bEven = !bEven;					//    - 
									//       
	fOld = bEven ? F1 : F2;			//   (-)
	fNew = bEven ? F2 : F1;
									//     8 
	UINT y, x, k, n, i[8], j[8];
									//       
	UINT xMin=MaxSize*MaxScale, yMin=xMin;
	LifeStatus was, is;				//   

	for (y=1; y<uY; ++y)			//   
	{
		i[1]=i[5]=y;				// Y- 2-    
		i[0]=i[6]=i[7]=y-1;			// Y- 3-  
		i[2]=i[3]=i[4]=y+1;			// Y- 3-  

		for (x=1; x<uX; ++x)		//   
		{
			j[3]=j[7]=x;			// X- 2-    
			j[0]=j[1]=j[2]=x-1;		// X- 3-  
			j[4]=j[5]=j[6]=x+1;		// X- 3-  

			for (k=0, n=0;  k<8;  ++k)
			{						//   8 
									//   
				was = (LifeStatus)fOld [i[k]][j[k]];
									//  ,      
				if (was==Young || was==Old)
					n++;
			}
									//    
			was = (LifeStatus) fOld[y][x];
									//  ?
			bool alive = was==Young || was==Old;
									//    ?
			is =	alive && (n<2 || 3<n) ? Died	// 
				:	alive &&  1<n && n<4  ? Old		// 
				:	!alive &&  n==3 ? Young			// 
									//  ?   
				:	was==Erase ? None
									//  ?  
				:	was==Died  ? Erase : None;

			fNew[y][x] = is;		//   
			if (is==Young || is==Old)
			{			//  ,    
						//     
				xMin = x<xMin ? x : xMin;
				yMin = y<yMin ? y : yMin;
			}
		}
	}
						//   
	ptScroll = CPoint (xMin-6, yMin-6);
						//   
	while (ptScroll.x++ < 0 )
		;
	while (ptScroll.y++ < 0 )
		;
	UpdateAllViews (NULL);	//     
}
