// SizeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "life.h"
#include "LifeDoc.h"
#include "SizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSizeDlg dialog


CSizeDlg::CSizeDlg (CLifeDoc* p)
		: CDialog (CSizeDlg::IDD, NULL)
{
	pDoc = p;	//   
}


void CSizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSizeDlg)
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_SCALE, pDoc->uScale);
	DDV_MinMaxUInt(pDX, pDoc->uScale, MinScale, MaxScale);
	DDX_Text(pDX, IDC_WIDTH, pDoc->uX);
	DDV_MinMaxUInt(pDX, pDoc->uX, MinSize, MaxSize);
	DDX_Text(pDX, IDC_HEIGHT, pDoc->uY);
	DDV_MinMaxUInt(pDX, pDoc->uY, MinSize, MaxSize);
	DDX_Text(pDX, IDC_TIMER, pDoc->uTime);
	DDV_MinMaxUInt(pDX, pDoc->uTime, 100, 5000);
}


BEGIN_MESSAGE_MAP(CSizeDlg, CDialog)
	//{{AFX_MSG_MAP(CSizeDlg)
	ON_BN_CLICKED(IDC_DIED, OnDied)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_BN_CLICKED(IDC_OLD, OnOld)
	ON_EN_CHANGE(IDC_HEIGHT, OnChangeSize)
	ON_EN_CHANGE(IDC_WIDTH, OnChangeSize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSizeDlg message handlers

void CSizeDlg::OnDied() 
{			//      ChooseColor,
			//      
	pDoc->DiedColor = ChooseColor (pDoc->DiedColor);
}

void CSizeDlg::OnNew() 
{
	pDoc->NewColor = ChooseColor (pDoc->NewColor);	
}

void CSizeDlg::OnOld() 
{
	pDoc->OldColor = ChooseColor (pDoc->OldColor);	
}

void CSizeDlg::OnChangeSize() 
{			//      
	pDoc->bSizeChanged=true;
}

COLORREF CSizeDlg::ChooseColor (COLORREF color)
{
	CColorDialog dlg(color);
	if (dlg.DoModal()==IDOK)
		color = dlg.m_cc.rgbResult;
	return color;
}
